// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: circuitsegmentservicemodule/circuitsegmentservicemodule.proto

package openfmb.circuitsegmentservicemodule;

/**
 * <pre>
 * Switch event
 * </pre>
 *
 * Protobuf type {@code circuitsegmentservicemodule.CircuitSegmentStatus}
 */
public final class CircuitSegmentStatus extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:circuitsegmentservicemodule.CircuitSegmentStatus)
    CircuitSegmentStatusOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CircuitSegmentStatus.newBuilder() to construct.
  private CircuitSegmentStatus(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CircuitSegmentStatus() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CircuitSegmentStatus();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentStatus_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentStatus_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.class, openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.Builder.class);
  }

  public static final int IDENTIFIEDOBJECT_FIELD_NUMBER = 1;
  private openfmb.commonmodule.IdentifiedObject identifiedObject_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the identifiedObject field is set.
   */
  @java.lang.Override
  public boolean hasIdentifiedObject() {
    return identifiedObject_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return The identifiedObject.
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }

  public static final int CIRCUITSEGMENTSTATUSDCSC_FIELD_NUMBER = 2;
  private openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the circuitSegmentStatusDCSC field is set.
   */
  @java.lang.Override
  public boolean hasCircuitSegmentStatusDCSC() {
    return circuitSegmentStatusDCSC_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The circuitSegmentStatusDCSC.
   */
  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC getCircuitSegmentStatusDCSC() {
    return circuitSegmentStatusDCSC_ == null ? openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.getDefaultInstance() : circuitSegmentStatusDCSC_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSCOrBuilder getCircuitSegmentStatusDCSCOrBuilder() {
    return circuitSegmentStatusDCSC_ == null ? openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.getDefaultInstance() : circuitSegmentStatusDCSC_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (identifiedObject_ != null) {
      output.writeMessage(1, getIdentifiedObject());
    }
    if (circuitSegmentStatusDCSC_ != null) {
      output.writeMessage(2, getCircuitSegmentStatusDCSC());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (identifiedObject_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getIdentifiedObject());
    }
    if (circuitSegmentStatusDCSC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getCircuitSegmentStatusDCSC());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.circuitsegmentservicemodule.CircuitSegmentStatus)) {
      return super.equals(obj);
    }
    openfmb.circuitsegmentservicemodule.CircuitSegmentStatus other = (openfmb.circuitsegmentservicemodule.CircuitSegmentStatus) obj;

    if (hasIdentifiedObject() != other.hasIdentifiedObject()) return false;
    if (hasIdentifiedObject()) {
      if (!getIdentifiedObject()
          .equals(other.getIdentifiedObject())) return false;
    }
    if (hasCircuitSegmentStatusDCSC() != other.hasCircuitSegmentStatusDCSC()) return false;
    if (hasCircuitSegmentStatusDCSC()) {
      if (!getCircuitSegmentStatusDCSC()
          .equals(other.getCircuitSegmentStatusDCSC())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasIdentifiedObject()) {
      hash = (37 * hash) + IDENTIFIEDOBJECT_FIELD_NUMBER;
      hash = (53 * hash) + getIdentifiedObject().hashCode();
    }
    if (hasCircuitSegmentStatusDCSC()) {
      hash = (37 * hash) + CIRCUITSEGMENTSTATUSDCSC_FIELD_NUMBER;
      hash = (53 * hash) + getCircuitSegmentStatusDCSC().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.circuitsegmentservicemodule.CircuitSegmentStatus prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Switch event
   * </pre>
   *
   * Protobuf type {@code circuitsegmentservicemodule.CircuitSegmentStatus}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:circuitsegmentservicemodule.CircuitSegmentStatus)
      openfmb.circuitsegmentservicemodule.CircuitSegmentStatusOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentStatus_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentStatus_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.class, openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.Builder.class);
    }

    // Construct using openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      circuitSegmentStatusDCSC_ = null;
      if (circuitSegmentStatusDCSCBuilder_ != null) {
        circuitSegmentStatusDCSCBuilder_.dispose();
        circuitSegmentStatusDCSCBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.circuitsegmentservicemodule.Circuitsegmentservicemodule.internal_static_circuitsegmentservicemodule_CircuitSegmentStatus_descriptor;
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatus getDefaultInstanceForType() {
      return openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatus build() {
      openfmb.circuitsegmentservicemodule.CircuitSegmentStatus result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatus buildPartial() {
      openfmb.circuitsegmentservicemodule.CircuitSegmentStatus result = new openfmb.circuitsegmentservicemodule.CircuitSegmentStatus(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.circuitsegmentservicemodule.CircuitSegmentStatus result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.identifiedObject_ = identifiedObjectBuilder_ == null
            ? identifiedObject_
            : identifiedObjectBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.circuitSegmentStatusDCSC_ = circuitSegmentStatusDCSCBuilder_ == null
            ? circuitSegmentStatusDCSC_
            : circuitSegmentStatusDCSCBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.circuitsegmentservicemodule.CircuitSegmentStatus) {
        return mergeFrom((openfmb.circuitsegmentservicemodule.CircuitSegmentStatus)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.circuitsegmentservicemodule.CircuitSegmentStatus other) {
      if (other == openfmb.circuitsegmentservicemodule.CircuitSegmentStatus.getDefaultInstance()) return this;
      if (other.hasIdentifiedObject()) {
        mergeIdentifiedObject(other.getIdentifiedObject());
      }
      if (other.hasCircuitSegmentStatusDCSC()) {
        mergeCircuitSegmentStatusDCSC(other.getCircuitSegmentStatusDCSC());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getIdentifiedObjectFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getCircuitSegmentStatusDCSCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.IdentifiedObject identifiedObject_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> identifiedObjectBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the identifiedObject field is set.
     */
    public boolean hasIdentifiedObject() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return The identifiedObject.
     */
    public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
      if (identifiedObjectBuilder_ == null) {
        return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      } else {
        return identifiedObjectBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        identifiedObject_ = value;
      } else {
        identifiedObjectBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(
        openfmb.commonmodule.IdentifiedObject.Builder builderForValue) {
      if (identifiedObjectBuilder_ == null) {
        identifiedObject_ = builderForValue.build();
      } else {
        identifiedObjectBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          identifiedObject_ != null &&
          identifiedObject_ != openfmb.commonmodule.IdentifiedObject.getDefaultInstance()) {
          getIdentifiedObjectBuilder().mergeFrom(value);
        } else {
          identifiedObject_ = value;
        }
      } else {
        identifiedObjectBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearIdentifiedObject() {
      bitField0_ = (bitField0_ & ~0x00000001);
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObject.Builder getIdentifiedObjectBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getIdentifiedObjectFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
      if (identifiedObjectBuilder_ != null) {
        return identifiedObjectBuilder_.getMessageOrBuilder();
      } else {
        return identifiedObject_ == null ?
            openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> 
        getIdentifiedObjectFieldBuilder() {
      if (identifiedObjectBuilder_ == null) {
        identifiedObjectBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder>(
                getIdentifiedObject(),
                getParentForChildren(),
                isClean());
        identifiedObject_ = null;
      }
      return identifiedObjectBuilder_;
    }

    private openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.Builder, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSCOrBuilder> circuitSegmentStatusDCSCBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the circuitSegmentStatusDCSC field is set.
     */
    public boolean hasCircuitSegmentStatusDCSC() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The circuitSegmentStatusDCSC.
     */
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC getCircuitSegmentStatusDCSC() {
      if (circuitSegmentStatusDCSCBuilder_ == null) {
        return circuitSegmentStatusDCSC_ == null ? openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.getDefaultInstance() : circuitSegmentStatusDCSC_;
      } else {
        return circuitSegmentStatusDCSCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCircuitSegmentStatusDCSC(openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC value) {
      if (circuitSegmentStatusDCSCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        circuitSegmentStatusDCSC_ = value;
      } else {
        circuitSegmentStatusDCSCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCircuitSegmentStatusDCSC(
        openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.Builder builderForValue) {
      if (circuitSegmentStatusDCSCBuilder_ == null) {
        circuitSegmentStatusDCSC_ = builderForValue.build();
      } else {
        circuitSegmentStatusDCSCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeCircuitSegmentStatusDCSC(openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC value) {
      if (circuitSegmentStatusDCSCBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          circuitSegmentStatusDCSC_ != null &&
          circuitSegmentStatusDCSC_ != openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.getDefaultInstance()) {
          getCircuitSegmentStatusDCSCBuilder().mergeFrom(value);
        } else {
          circuitSegmentStatusDCSC_ = value;
        }
      } else {
        circuitSegmentStatusDCSCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearCircuitSegmentStatusDCSC() {
      bitField0_ = (bitField0_ & ~0x00000002);
      circuitSegmentStatusDCSC_ = null;
      if (circuitSegmentStatusDCSCBuilder_ != null) {
        circuitSegmentStatusDCSCBuilder_.dispose();
        circuitSegmentStatusDCSCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.Builder getCircuitSegmentStatusDCSCBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getCircuitSegmentStatusDCSCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSCOrBuilder getCircuitSegmentStatusDCSCOrBuilder() {
      if (circuitSegmentStatusDCSCBuilder_ != null) {
        return circuitSegmentStatusDCSCBuilder_.getMessageOrBuilder();
      } else {
        return circuitSegmentStatusDCSC_ == null ?
            openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.getDefaultInstance() : circuitSegmentStatusDCSC_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.circuitsegmentservicemodule.CircuitSegmentStatusDCSC circuitSegmentStatusDCSC = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.Builder, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSCOrBuilder> 
        getCircuitSegmentStatusDCSCFieldBuilder() {
      if (circuitSegmentStatusDCSCBuilder_ == null) {
        circuitSegmentStatusDCSCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSC.Builder, openfmb.circuitsegmentservicemodule.CircuitSegmentStatusDCSCOrBuilder>(
                getCircuitSegmentStatusDCSC(),
                getParentForChildren(),
                isClean());
        circuitSegmentStatusDCSC_ = null;
      }
      return circuitSegmentStatusDCSCBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:circuitsegmentservicemodule.CircuitSegmentStatus)
  }

  // @@protoc_insertion_point(class_scope:circuitsegmentservicemodule.CircuitSegmentStatus)
  private static final openfmb.circuitsegmentservicemodule.CircuitSegmentStatus DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.circuitsegmentservicemodule.CircuitSegmentStatus();
  }

  public static openfmb.circuitsegmentservicemodule.CircuitSegmentStatus getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CircuitSegmentStatus>
      PARSER = new com.google.protobuf.AbstractParser<CircuitSegmentStatus>() {
    @java.lang.Override
    public CircuitSegmentStatus parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CircuitSegmentStatus> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CircuitSegmentStatus> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.circuitsegmentservicemodule.CircuitSegmentStatus getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

